<template>
  <BasicModal
    v-bind="$attrs"
    destroyOnClose
    @register="registerModal"
    :title="getTitle"
    :width="width"
    @ok="handleSubmit"
    :showFooter="true"
  >
    <BasicForm @register="registerForm" layout="vertical" class="!px-6 !pt-4" />
  </BasicModal>
</template>
<script lang="ts" setup>
  import { ref, unref } from 'vue';
  import { BasicModal, useModalInner } from '/@/components/Modal';
  import { BasicForm, useForm } from '/@/components/Form';
  import { useMessage } from '/@/hooks/web/useMessage';
  import { dataFormSchema } from './data';

  import {
    bedScheduledPersonAdd,
    bedScheduledPersonEdit,
    bedScheduledPersonDetail,
  } from '/@/api/biz/bed/scheduledPersonApi';
  import dayjs from 'dayjs';

  const emit = defineEmits(['success', 'register']);

  const getTitle = ref();
  const width = '45%';
  const isUpdate = ref(false);
  const rowId = ref();

  const { createMessage } = useMessage();
  const [registerForm, { setFieldsValue, resetFields, validate }] = useForm({
    labelWidth: 100,
    schemas: dataFormSchema,
    showActionButtonGroup: false,
    baseColProps: {
      span: 12,
    },
  });
  const [registerModal, { setModalProps, closeModal }] = useModalInner(async data => {
    await resetFields();
    setModalProps({ confirmLoading: false });
    isUpdate.value = !!data?.isUpdate;
    getTitle.value = `${isUpdate.value ? '编辑排班' : '新建排班'} ( ${data.record.patientName} | ${
      data.record.gender
    } | ${data.record.age}岁 )`;

    if (unref(isUpdate)) {
      const resData = await bedScheduledPersonDetail(data.record.id);
      console.log('🚀 ~ file: FormModal.vue:54 ~ resData:', resData);
      rowId.value = resData.id;
      const fieldsData = Object.assign(resData, {
        frequency: {
          input: 1,
          dictValue: resData.frequency?.week == 1 ? 'week_1' : 'week_2',
        },
      });
      console.log('🚀 ~ file: FormModal.vue:62 ~ fieldsData:', fieldsData);
      await setFieldsValue({
        ...fieldsData,
        // ...resData,
        // machine: ['pump_single'],
        // patientUniqueNo: resData.patientUniqueNo,
        // archivesCreateTime: resData.archivesCreateTime,
        // patientType: resData.patientType,
        // special: resData.special,
        // frequency: {
        //   input: 1,
        //   dictValue: resData.frequency?.week == 1 ? 'week_1' : 'week_2',
        // },
      });
    } else {
      await setFieldsValue({
        appointmentDate: dayjs().format('YYYY-MM-DD'),
      });
    }
  });

  // 提交按钮事件
  async function handleSubmit() {
    try {
      const values = await validate();
      setModalProps({ confirmLoading: true });
      !unref(isUpdate)
        ? await bedScheduledPersonAdd({ ...values })
        : await bedScheduledPersonEdit({ ...values, id: rowId.value });
      !unref(isUpdate) ? createMessage.success('新增成功！') : createMessage.success('编辑成功！');
      closeModal();
      emit('success', {
        isUpdate: unref(isUpdate),
        values: { ...values, id: rowId.value },
      });
    } finally {
      setModalProps({ confirmLoading: false });
    }
  }
</script>
